/* Problem URL: https://codeforces.com/contest/920/problem/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    vi div(1e6 + 1, 1);

    nrep(i, 2, 1e6 + 1) {
        if (div[i] > 1) {
            continue;
        }

        for (int j = i; j <= 1e6; j += i) {
            div[j] = i;
        }
    }

    vi f(1e6 + 1);
    f[1] = 1;
    f[2] = 2;

    nrep(i, 3, 1e6 + 1) {
        int now = 1;
        int tmp = i;

        while (tmp > 1) {
            int count = 1;
            int prime = div[tmp];

            while (tmp % prime == 0) {
                tmp /= prime;
                count++;
            }

            now *= count;
        }

        f[i] = now;
    }

    int n, m;
    cin >> n >> m;

    vi fds(n);
    cin >> fds;

    while (__builtin_popcount(n) != 1) {
        n++;
        fds.push_back(1);
    }

    V<pair<int, ll>> seg(n * 2);

    nrep(i, n, n * 2) {
        seg[i] = {fds[i - n], fds[i - n]};
    }

    for (int i = n - 1; i > 0; i--) {
        seg[i] = {max(seg[i * 2].first, seg[i * 2 + 1].first), seg[i * 2].second + seg[i * 2 + 1].second};
    }

    function<void(int, int, int ,int, int)> update = [&](int i, int l, int r, int tl, int tr) {
        if (l > tr || r < tl || seg[i].first <= 2) {
            return;
        }

        if (l == r) {
            seg[i] = {f[seg[i].first], f[seg[i].first]};
            return;
        }

        int mid = (l + r) >> 1;

        update(i * 2, l, mid, tl, tr);
        update(i * 2 + 1, mid + 1, r, tl, tr);

        seg[i] = {max(seg[i * 2].first, seg[i * 2 + 1].first), seg[i * 2].second + seg[i * 2 + 1].second};
    };

    function<ll(int, int, int, int, int)> query = [&](int i, int l, int r, int tl, int tr) {
        if (l > tr || r < tl) {
            return 0LL;
        }

        if (l >= tl && r <= tr) {
            return seg[i].second;
        }

        int mid = (l + r) >> 1;

        return query(i * 2, l, mid, tl, tr) + query(i * 2 + 1, mid + 1, r, tl, tr);
    };

    while (m--) {
        int t, l, r;
        cin >> t >> l >> r;
        l--, r--;

        if (t == 1) {
            update(1, 0, n - 1, l, r);
            continue;
        }

        cout << query(1, 0, n - 1, l, r) << '\n';
    }
}
